# walnut_kernel 

``walnut_kernel`` is a simple Jupyter kernel for [Walnut](https://cs.uwaterloo.ca/~shallit/walnut.html).

# Installation

To install `walnut_kernel` from PyPI:
```
    pip install walnut_kernel
```
    
# Using the Walnut kernel

Before using the kernel with notebooks or console frontends, you need a compiled copy of [Walnut](https://github.com/firetto/Walnut) and to set the following environment variables:
 - `WALNUT_HOME` should point to a writable directory containing all the Walnut files (`Result/`, `Custom Bases/`, ...);
 - `WALNUT_JAR` should point to the `walnut.jar` main JAR file.

# Magic commands

This kernel is build with [Metakernel](https://jupyter-client.readthedocs.io/en/stable/wrapperkernels.html) and supports several convenient [magic functions](https://metakernel.readthedocs.io/en/latest/) including `%%file` and `%%python`.

This kernel also provides its own magics:
 - `%showme LAPIN`: displays the graphiz file `Result/LAPIN.gv` (convenient to display automata in notebooks);
 - `%DT blop "a->ab, b->a"`: compute the Dumont-Thomas numeration system associated to the substitution `a->ab, b->a` with its addition. The resulting numeration system is `msd_blop` and the DFAO is `Blop`;
 - `%DT blop "a->aba, b->b" 30`: when the Dumont-Thomas numeration system is not X-Pisot, a bound is needed;
 - `%SGT maple ns dfao`: compute the DFAO `dfao` in numeration system `ns` using the semigroup trick from the linear representation of a rational serie given in Maple file `maple` (generated by Walnut);
 - `%EQ maple1 maple2`: test if the rational series given in the Maple files `maple1` and `maple2` (generated by Walnut) are equal.
